<template>
  <transition name="fly">
    <div
      v-if="displayLoginMessage && account.level !== 'vip'"
      class="login-message-panel"
    >
      <div class="panel-body" :class="themeClasses">
        <i class="card-icon" :class="themeClasses"></i>
        <h3
          class="panel-title"
          v-html="
            $t(`loginMessage.${account.level}.title`, {
              level: account.levelTitle,
              name: account.name
            })
          "
        ></h3>
        <p
          class="login-message"
          v-html="
            $t(`loginMessage.${account.level}.message`, {
              level: account.levelTitle
            })
          "
        ></p>
        <button @click.prevent.stop="closeLoginMessage()" class="close-icon">
          close
        </button>
        <button @click.prevent.stop="closeLoginMessage()" class="close-button">
          {{ $t(`loginMessage.${account.level}.closeButton`) }}
        </button>
      </div>
    </div>
  </transition>
</template>

<script>
import { mapGetters, mapState, mapActions } from "vuex";
import { LaurelCrownBlock } from "@/components/LaurelCrownBlock";

export default {
  components: {
    LaurelCrownBlock
  },

  computed: {
    ...mapState("account", ["account"]),
    ...mapGetters("theme", ["themeClasses"]),
    ...mapGetters("account", ["displayLoginMessage", "isVipMember"])
  },

  methods: {
    ...mapActions("account", ["closeLoginMessage"])
  }
};
</script>

<style lang="scss" scoped>
.login-message-panel {
  position: fixed;
  left: 0;
  top: 0;
  z-index: 1001;
  width: 100%;
  height: 100%;
  background: rgba(0, 0, 0, 0.32);
  text-align: center;

  &:before {
    content: "";
    height: 100%;
    display: inline-block;
    vertical-align: middle;
  }
}

.panel-body {
  display: inline-block;
  vertical-align: middle;
  box-sizing: border-box;
  padding: 25px 25px 20px;
  width: 90%;
  max-width: 335px;
  position: relative;
  max-height: 100%;
  overflow-y: scroll;

  @include media-breakpoint-up(md) {
    width: 540px;
    max-width: 540px;
    padding: 30px 40px 40px;

    &.theme-map-member {
      padding-top: 60px;
    }
  }

  &.theme-vip-member {
    background-color: $color-white;
    background-image: url("/static/images/vip-login-message-bg.png");
    background-size: 335px 460px;
    background-position: center center;
  }

  &.theme-general-member {
    &:after {
      content: "";
      position: absolute;
      width: 100%;
      height: 100%;
      background: $color-white;
      top: 0;
      left: 0;
      z-index: -2;
    }

    &:before {
      content: "";
      position: absolute;
      background-image: url("/static/images/general-member-login-bg.png");
      background-size: 392.4px 417.6px;
      background-position: center center;
      background-repeat: no-repeat;
      opacity: 0.08;
      width: 100%;
      height: 100%;
      left: 0;
      top: 0;
      z-index: -1;

      @include media-breakpoint-up(md) {
        background-size: 540px 600px;
      }
    }
  }

  &.theme-map-member {
    &:after,
    &:before {
      display: none;
    }
    background-image: linear-gradient(to left, #ebebeb, #ffffff 49%, #ebebeb);
  }
}

.card-icon {
  display: block;
  height: 43px;
  background-image: url("/static/images/ic-general-card.png");
  background-size: 51px 43px;
  background-position: center center;
  background-repeat: no-repeat;
  margin-bottom: 10px;

  @include media-breakpoint-up(md) {
    background-size: 76.5px 64.5px;
    height: 64.5px;
    margin-bottom: 35px;
  }

  &.theme-map-member {
    display: none;
  }
}

.panel-title {
  font-size: 18px;
  line-height: 1.5em;
  margin-bottom: 20px;

  @include media-breakpoint-up(md) {
    font-size: 28px;
    margin-bottom: 40px;
  }
}

.login-message {
  font-size: 14px;
  line-height: 2em;
  margin-bottom: 41px;

  @include media-breakpoint-up(md) {
    font-size: 18px;
    margin-bottom: 65px;
  }
}

.theme-vip-member .login-message {
  margin-bottom: 20px;
}

.close-icon {
  background: none;
  border: none;
  width: 15px;
  height: 15px;
  position: absolute;
  right: 20px;
  top: 20px;
  text-indent: -1000px;
  padding: 0;
  margin: 0;
  cursor: pointer;
  overflow: hidden;

  &:before,
  &:after {
    content: "";
    position: absolute;
    left: 0;
    top: 7px;
    height: 2px;
    width: 100%;
    border-radius: 1px;
    background: $color-primary-black;
  }

  &:before {
    transform: rotateZ(45deg);
  }

  &:after {
    transform: rotateZ(-45deg);
  }
}

.fly-enter-active,
.fly-leave-active {
  transition: opacity 0.5s;
}

.fly-enter,
.fly-leave-to {
  opacity: 0;
}

.close-button {
  display: block;
  max-width: 235px;
  width: 100%;
  line-height: 48px;
  text-align: center;
  padding: 0;
  margin: 0 auto;
  background: $color-skm-red;
  color: $color-white;
  border: none;
  border-radius: 2px;
  cursor: pointer;
}

.theme-vip-member .card-icon {
  background-image: url("/static/images/ic-vip-card.png");
}

.theme-vip-member .close-icon {
  &:before,
  &:after {
    background: $color-white;
  }
}

.desc-image {
  width: 216px;
  height: 115px;
  margin-bottom: 33px;
}

.treatments-wrapper {
  text-align: center;
}

.treatments {
  display: inline-block;
  width: auto;
}

.treatment {
  margin-bottom: 26px;
}

.treatment-title {
  color: $color-skm-red;
}
</style>
